<template>
  <div class="app-container">
    <!-- <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-refresh"
          size="mini"
          @click="handleQuery"
          >刷新</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form> -->

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          >新增</el-button
        >
      </el-col>
      <!-- <el-col :span="1.5">
          <el-button
            type="success"
            plain
            icon="el-icon-edit"
            size="mini"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['system:information:edit']"
          >修改</el-button>
        </el-col> -->
      <!-- <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:information:remove']"
          >删除</el-button
        >
      </el-col> -->
      <!-- <el-col :span="1.5">
          <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['system:information:export']"
          >导出</el-button>
        </el-col> -->
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="informationList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column
        label="ID"
        align="center"
        prop="id"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="标题"
        align="center"
        prop="title"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="城市"
        align="center"
        prop="cityName"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="封面" align="center" prop="cover" width="170">
        <template slot-scope="{ row }">
          <!-- <el-image
            style="width: 30px; height: 30px"
            :src="row.cover"
            :preview-src-list="[row.cover]"
          >
          </el-image> -->
          <imageUpload
            v-if="row.cover"
            v-model="row.cover"
            :limit="row.cover.split(',').length"
            :isShowTip="false"
            :disabled="true"
          ></imageUpload>
        </template>
      </el-table-column>
      <el-table-column label="内容" align="center" prop="info">
        <template slot-scope="{ row }">
          <el-button type="text" @click="handleLook(row)">点击查看</el-button>
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        width="180"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="更新时间"
        align="center"
        prop="updateTime"
        width="180"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            >编辑</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改新闻资讯对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="50%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入标题" />
        </el-form-item>
        <el-form-item label="城市" prop="cityId">
          <el-select
            filterable
            clearable
            v-model="form.cityId"
            placeholder="请选择"
          >
            <el-option
              v-for="item in cityVoList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="封面" prop="cover">
          <imageUpload v-model="form.cover"></imageUpload>
        </el-form-item>
        <el-form-item label="内容" prop="info">
          <editor v-model="form.info" :min-height="192" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :loading="buttonLoading" type="primary" @click="submitForm"
          >确 定</el-button
        >
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 查看内容弹框 -->
    <template v-if="openArticle">
      <el-dialog
        title="文章内容"
        :visible.sync="openArticle"
        width="50%"
        append-to-body
      >
        <div class="hidden-dialog">
          <div class="content" v-html="rowArticle"></div>
        </div>
      </el-dialog>
    </template>
  </div>
</template>

<script>
import {
  listInformation,
  getInformation,
  delInformation,
  addInformation,
  updateInformation,
} from "@/api/operation/news";
import { cityVoListGET } from "@/api/hispotalManage/hospital";

export default {
  name: "Information",
  data() {
    return {
      // 按钮loading
      buttonLoading: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 新闻资讯表格数据
      informationList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        cityId: undefined,
        title: undefined,
        cover: undefined,
        info: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        cityId: [{ required: true, message: "请选择城市", trigger: "change" }],
      },
      openArticle: false,
      rowArticle: undefined,
      cityVoList: [],
    };
  },
  created() {
    this.getList();
    this.cityVoListAxios();
  },
  methods: {
    /** 查询新闻资讯列表 */
    getList() {
      this.loading = true;
      listInformation(this.queryParams).then((response) => {
        this.informationList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    async cityVoListAxios() {
      const data_back = await cityVoListGET();
      const { code, data } = data_back;
      if (code === 200) {
        this.cityVoList = data;
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        cityId: undefined,
        title: undefined,
        cover: undefined,
        info: undefined,
        createBy: undefined,
        createTime: undefined,
        updateBy: undefined,
        updateTime: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加新闻资讯";
    },
    handleLook(row) {
      console.log(row, "查拉吗");
      this.openArticle = true;
      this.rowArticle = this.replaceSpecialChar(row.info);
    },
    replaceSpecialChar(detail) {
      var content = detail.replaceAll(
        /<img[^>]*>/gi,
        function (match, capture) {
          var match = match.replaceAll(
            /(style="(.*?)")|(width="(.*?)")|(height="(.*?)")/gi,
            ``
          ); //清空自带的width，height
          match = match.replaceAll(
            "<img",
            '<img style="max-width:100%;margin: 0 auto;"'
          );
          console.log(match, "change"); //设置最大宽度
          return match;
        }
      );
      return content;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.reset();
      const id = row.id || this.ids;
      getInformation(id).then((response) => {
        this.loading = false;
        this.form = response.data;
        this.open = true;
        this.title = "修改新闻资讯";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            updateInformation(this.form)
              .then((response) => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              })
              .finally(() => {
                this.buttonLoading = false;
              });
          } else {
            addInformation(this.form)
              .then((response) => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              })
              .finally(() => {
                this.buttonLoading = false;
              });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除新闻资讯编号为"' + ids + '"的数据项？')
        .then(() => {
          this.loading = true;
          return delInformation(ids);
        })
        .then(() => {
          this.loading = false;
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {})
        .finally(() => {
          this.loading = false;
        });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "system/information/export",
        {
          ...this.queryParams,
        },
        `information_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
<style scoped>
.hidden-dialog {
  height: 500px;
  overflow-x: hidden;
}
.content {
  width: 100%;
}
</style>
